#ifndef LC3GV_H
#define LC3GV_H

/* Copyright (C) logi.cals GmbH. All rights reserved. */

/*
** TASK      :: global variable defines
** NOTES     ::
*/

/***************************************************************************
** Global Includes, Defines , Types
****************************************************************************/
#include <LCAPI.h>

#include <lcpu___revolutionpifilewriteprogram.gv.h>


typedef struct
{
  LC_TD_WORD LC_VD_INPUT;
  LC_TD_WORD LC_VD_OUTPUT;
  LC_TD_BOOL _LC_VD_dummy;        /* dummy structure member - to avoid empty struct, when no GVs are defined */
} LCCG_StructAttrib LC_TD_LC3_GVType;

/*                   ColdBoot Initialization Macro             */
#define LC_INIT_NONDMA_LC3_GVType(p) \
  LC_GV_INIT_ELEM(pEPDB,LC_VD_INPUT,LC_TD_WORD) = (LC_TD_WORD)0; \
  LC_GV_INIT_ELEM(pEPDB,LC_VD_OUTPUT,LC_TD_WORD) = (LC_TD_WORD)0; \

#define LC_INIT_LC3_GVType(p) \
{ \
  LC_INIT_NONDMA_LC3_GVType(p) \
}


/*                   WarmBoot Initialization Macro             */
#define LC_WINIT_NONDMA_LC3_GVType(p,RF) \
  if (RF==0) LC_GV_INIT_ELEM(pEPDB,LC_VD_INPUT,LC_TD_WORD) = (LC_TD_WORD)0; \
  if (RF==0) LC_GV_INIT_ELEM(pEPDB,LC_VD_OUTPUT,LC_TD_WORD) = (LC_TD_WORD)0; \

#define LC_WINIT_LC3_GVType(p,RF) \
{ \
  LC_WINIT_NONDMA_LC3_GVType(p,RF) \
}


#define LCNS_EL_INI___VAR_GLOBAL \
  { \
    {\
      sizeof(RTTypeNS_ElementNode), \
      "INPUT", \
      2, \
      offsetof(LC_TD_LC3_GVType,LC_VD_INPUT), \
      sizeof(LC_TD_WORD), \
      LCOOS_VAREXP_VAR_GLOBAL, \
      NULL, \
      LCOOS_VAREXP_WORD, \
      "WORD", \
      NULL, \
      LCNS_PHYS_ADDR_STR___INPUT /* %IW1.11 */, \
      LCNS_PHYS_ADDR_NUM___INPUT, \
      NULL, \
      LCNS_IO_FLAG___INPUT \
    }\
    ,\
    {\
      sizeof(RTTypeNS_ElementNode), \
      "OUTPUT", \
      2, \
      offsetof(LC_TD_LC3_GVType,LC_VD_OUTPUT), \
      sizeof(LC_TD_WORD), \
      LCOOS_VAREXP_VAR_GLOBAL, \
      NULL, \
      LCOOS_VAREXP_WORD, \
      "WORD", \
      NULL, \
      LCNS_PHYS_ADDR_STR___OUTPUT /* %QW1.81 */, \
      LCNS_PHYS_ADDR_NUM___OUTPUT, \
      NULL, \
      LCNS_IO_FLAG___OUTPUT \
    }\
  }
#define LCNS_EL_CNT_VAR_GLOBAL_NONDMA 2
#define LCNS_EL_CNT___VAR_GLOBAL (LCNS_EL_CNT_VAR_GLOBAL_NONDMA)




unsigned LC_GV_Init(LCoplck_EPDB * pEPDB, LCoplck_StartMode s);

extern LC_TD_LC3_GVType g_LC3_GVInstanceData;

#endif /* LC3GV_H */
