/* Copyright (C) logi.cals GmbH. All rights reserved. */
#ifndef __RTSSSYSTEM_H__
#define __RTSSSYSTEM_H__

/* ----------------------------- includes ----------------------------------- */
#if LC_GENERATED == 1
#include <LC3TDIECTypes.h>
#else
#include <RTSConfig.h>
#include <RTSAPI_IECTypes.h>
#endif /* LC_GENERATED */

/*****************************************************************************
 ** Global Defines
 *****************************************************************************/
#ifndef RTK_SS_SYSTEM_ID
/* must be aligned with definition in RTSService.h */
#define RTK_SS_SYSTEM_ID 0x10000010
#endif

#ifndef RTK_SS_SYSTEM_NAME
/* must be aligned with definition in RTSService.h */
#define RTK_SS_SYSTEM_NAME "RTSS_SYSTEM"
#endif

#define RTSS_SYSTEM_RC_OK                    0
#define RTSS_SYSTEM_RC_IDX_INVALID          -1
#define RTSS_SYSTEM_RC_NUM_BYTES_INVALID    -2
#define RTSS_SYSTEM_RC_SYSTEM_CALL_FAILED   -3
#define RTSS_SYSTEM_RC_SS_NOT_LOADED        -4

/*****************************************************************************
 ** Notifications
 *****************************************************************************/
#define RTSS_System_open_NOTIF    0x00000060L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LcCgChar const* LC_VD_PATHNAME;
  LC_TD_DINT LC_VD_FLAGS;
  LC_TD_DINT LC_VD_MODE;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_OPEN;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_open_DT;

#define RTSS_System_ioctl_NOTIF    0x00000061L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LC_TD_DINT LC_VD_FD;
  LC_TD_DINT LC_VD_REQUEST;
  LC_TD_DINT LC_VD_DATA;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_IOCTL;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_ioctl_DT;

#define RTSS_System_read_NOTIF    0x00000062L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LC_TD_DINT LC_VD_FD;
  LC_TD_DINT LC_VD_COUNT;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_READ;
  LC_TD_BYTE* LC_VD_DATA;
  LC_TD_DINT LC_VD_DATA_SIZE;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_read_DT;

#define RTSS_System_write_NOTIF    0x00000063L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LC_TD_DINT LC_VD_FD;
  LC_TD_DINT LC_VD_COUNT;
  LC_TD_BYTE* LC_VD_DATA;
  LC_TD_DINT LC_VD_DATA_SIZE;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_WRITE;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_write_DT;

#define RTSS_System_close_NOTIF    0x00000064L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LC_TD_DINT LC_VD_FD;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_CLOSE;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_close_DT;

#define RTSS_System_delete_NOTIF    0x00000065L
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;
  /* input parameters */
  LcCgChar const* LC_VD_PATHNAME;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_DELETE;
  LC_TD_DINT LC_VD_ERRNO;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_delete_DT;

typedef LC_TD_USINT RTSS_System_shutdown_mode_DT;
#define RTSS_System_shutdown_REBOOT    1
#define RTSS_System_shutdown_PWR_OFF   2
#define RTSS_System_shutdown_NOTIF     0x0000006EL
typedef struct
{
  LC_TD_UDINT LC_VD_SIZE;

  /* input parameters */
  RTSS_System_shutdown_mode_DT LC_VD_MODE;
  /* output parameters */
  LC_TD_DINT LC_VD_SYSTEM_SHUTDOWN;
  LC_TD_DINT LC_VD_RC;
} RTSS_System_shutdown_DT;

/*****************************************************************************
 ** Global Variables (extern Declarations)
 *****************************************************************************/

/*****************************************************************************
 ** ProtoTypes
 *****************************************************************************/

/*--------------------------------------------------------------------------*/
/* Resume compiler default packing and cpp-mode                             */
/*--------------------------------------------------------------------------*/

#endif
