#ifndef LC_PROT_LCFU_LOGILIBRARY__SYSTEM_OPEN__C
#define LC_PROT_LCFU_LOGILIBRARY__SYSTEM_OPEN__C

#include <lcfu_logilibrary__SYSTEM_OPEN.h>
#include <RTSS_SYSTEM.h>
#include <RTSAPI_Notify.h>
#include <RTSAPI_Errors.h>

/*                            Functions                        */
void lcfu_logilibrary__SYSTEM_OPEN(LC_TD_Function_SYSTEM_OPEN* LC_this, LC_TD_STRING LC_VD_PATHNAME, LC_TD_DINT LC_VD_FLAGS, LC_TD_DINT LC_VD_MODE, struct _lcoplck_epdb_1_impl* pEPDB)
{
  RTSS_System_open_DT lNotificationParam;
  RT_RC rc_rt_ss = RTK_RC_OK;

  lNotificationParam.LC_VD_SIZE = sizeof(lNotificationParam); /* mandatory */

  /* provide notification input */
  lNotificationParam.LC_VD_PATHNAME = LC_GET_STRING_PTR(LC_VD_PATHNAME);
  lNotificationParam.LC_VD_FLAGS = LC_VD_FLAGS;
  lNotificationParam.LC_VD_MODE = LC_VD_MODE;

  lNotificationParam.LC_VD_RC = RTSS_SYSTEM_RC_SS_NOT_LOADED;
  lNotificationParam.LC_VD_ERRNO = -1;
  lNotificationParam.LC_VD_SYSTEM_OPEN = -1;

  /* send notification and get return code */
  rc_rt_ss = rt_notify_ep(RTSS_System_open_NOTIF, RTK_SS_SYSTEM_ID, pEPDB, 0, &lNotificationParam);

  /* read output of the notification */
  LC_this->LC_VD_SYSTEM_OPEN = lNotificationParam.LC_VD_SYSTEM_OPEN;
  LC_this->LC_VD_ERRNO = lNotificationParam.LC_VD_ERRNO;
  LC_this->LC_VD_RC = lNotificationParam.LC_VD_RC;

  /* set ENO */
  LC_this->LC_VD_ENO = (rc_rt_ss == RTK_RC_OK && LC_this->LC_VD_SYSTEM_OPEN >= 0 && LC_this->LC_VD_RC == RTSS_SYSTEM_RC_OK) ? LC_EL_true : LC_EL_false;
}

#endif
