#ifndef LC_PROT_LCFU_LOGILIBRARY__SYSTEM_CLOSE__C
#define LC_PROT_LCFU_LOGILIBRARY__SYSTEM_CLOSE__C

#include <lcfu_logilibrary__SYSTEM_CLOSE.h>
#include <RTSS_SYSTEM.h>
#include <RTSAPI_Notify.h>
#include <RTSAPI_Errors.h>

/*                            Functions                        */
void lcfu_logilibrary__SYSTEM_CLOSE(LC_TD_Function_SYSTEM_CLOSE* LC_this, LC_TD_DINT LC_VD_FD, struct _lcoplck_epdb_1_impl* pEPDB)
{
  RTSS_System_close_DT lNotificationParam = { 0 };
  RT_RC rc_rt_ss = RTK_RC_OK;

  lNotificationParam.LC_VD_SIZE = sizeof(lNotificationParam); /* mandatory */

  /* provide notification input */
  lNotificationParam.LC_VD_FD = LC_VD_FD;

  lNotificationParam.LC_VD_RC = RTSS_SYSTEM_RC_SS_NOT_LOADED;
  lNotificationParam.LC_VD_ERRNO = -1;
  lNotificationParam.LC_VD_SYSTEM_CLOSE = -1;

  /* send notification and get return code */
  rc_rt_ss = rt_notify_ep(RTSS_System_close_NOTIF, RTK_SS_SYSTEM_ID, pEPDB, 0, &lNotificationParam);

  /* read output of the notification */
  LC_this->LC_VD_SYSTEM_CLOSE = lNotificationParam.LC_VD_SYSTEM_CLOSE;
  LC_this->LC_VD_ERRNO = lNotificationParam.LC_VD_ERRNO;
  LC_this->LC_VD_RC = lNotificationParam.LC_VD_RC;

  /* set ENO */
  LC_this->LC_VD_ENO = (rc_rt_ss == RTK_RC_OK && LC_this->LC_VD_SYSTEM_CLOSE >= 0 && LC_this->LC_VD_RC == RTSS_SYSTEM_RC_OK) ? LC_EL_true : LC_EL_false;
}

#endif
