/* Copyright (C) logi.cals GmbH. All rights reserved.             */

/*
** TASK :: C implementation of function LEN for RTS compatible Systems.
*/

#ifndef LC_PROT_LCFU_IEC61131__LEN__H
#define LC_PROT_LCFU_IEC61131__LEN__H

#include <LC3CGBase.h>
#include <LC3CGString.h>

/*                            Typedefs                            */
#define DEF_LC_TD_Function_LEN_ANY(type) \
typedef struct _LC_TD_Function_LEN__##type \
{ \
	LC_TD_BOOL LC_VD_ENO; \
	LC_TD_##type LC_VD_LEN; \
} LCCG_StructAttrib LC_TD_Function_LEN__##type;

DEF_LC_TD_Function_LEN_ANY(SINT)
DEF_LC_TD_Function_LEN_ANY(INT)
DEF_LC_TD_Function_LEN_ANY(DINT)
DEF_LC_TD_Function_LEN_ANY(LINT)
DEF_LC_TD_Function_LEN_ANY(USINT)
DEF_LC_TD_Function_LEN_ANY(UINT)
DEF_LC_TD_Function_LEN_ANY(UDINT)
DEF_LC_TD_Function_LEN_ANY(ULINT)

/*                      Initialization Macro                      */
#define LC_INIT_Function_LEN_ANY(p,type) \
{ \
	LC_INIT_##type(&((p)->LC_VD_LEN)); \
}

#define LC_INIT_Function_LEN__SINT(p)   LC_INIT_Function_LEN_ANY(p,SINT)
#define LC_INIT_Function_LEN__INT(p)    LC_INIT_Function_LEN_ANY(p,INT)
#define LC_INIT_Function_LEN__DINT(p)   LC_INIT_Function_LEN_ANY(p,DINT)
#define LC_INIT_Function_LEN__LINT(p)   LC_INIT_Function_LEN_ANY(p,LINT)
#define LC_INIT_Function_LEN__USINT(p)  LC_INIT_Function_LEN_ANY(p,USINT)
#define LC_INIT_Function_LEN__UINT(p)   LC_INIT_Function_LEN_ANY(p,UINT)
#define LC_INIT_Function_LEN__UDINT(p)  LC_INIT_Function_LEN_ANY(p,UDINT)
#define LC_INIT_Function_LEN__ULINT(p)  LC_INIT_Function_LEN_ANY(p,ULINT)

/*            Implementation of helper macros (inlined)           */
#define LC_MF_LEN_ANY(type,IN) (LC_TD_##type)LC_STRLEN(LC_GET_STRING_PTR(IN))

/*                       Impl (not inlined)                       */
#define lcfu_iec61131__LEN__SINT(LC_this, IN, pEPDB)  (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(SINT,IN)
#define lcfu_iec61131__LEN__INT(LC_this, IN, pEPDB)   (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(INT,IN)
#define lcfu_iec61131__LEN__DINT(LC_this, IN, pEPDB)  (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(DINT,IN)
#define lcfu_iec61131__LEN__LINT(LC_this, IN, pEPDB)  (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(LINT,IN)
#define lcfu_iec61131__LEN__USINT(LC_this, IN, pEPDB) (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(USINT,IN)
#define lcfu_iec61131__LEN__UINT(LC_this, IN, pEPDB)  (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(UINT,IN)
#define lcfu_iec61131__LEN__UDINT(LC_this, IN, pEPDB) (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(UDINT,IN)
#define lcfu_iec61131__LEN__ULINT(LC_this, IN, pEPDB) (LC_this)->LC_VD_LEN = LC_MF_LEN_ANY(ULINT,IN)

#endif
